/*
Firmware to manage the 'hidden' functions of a RTL8366CB
GBit switch.
(C) 2010 Jeroen Domburg (jeroen AT spritesmods.com)

This program is free software: you can redistribute it and/or modify
t under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
	    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
			    
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "menu.h"
#include <stdio.h>

static char *getSubStr(PGM_P menuString, int item, char *dst, void (getData)(int menuItem, int no, char* buff)) {
	int pctPos=0;
	int i=0, j=0, p=0;
	char pctBuff[64];
	//Go to start of correct item
	while (p!=item) {
		i++;
		while (pgm_read_byte(menuString+i)!=0 && pgm_read_byte(menuString+i)!='\n') i++;
		p++;
	}
	if (pgm_read_byte(menuString+i)==0) return NULL;
	if (item!=0) i++;
	//Ok, i is now at the start of the item. Copy to dst, expanding %s if necessary.
	while (pgm_read_byte(menuString+i)!=0 && pgm_read_byte(menuString+i)!='\n') {
		char c=pgm_read_byte(menuString+i);
		if (c=='%' && getData!=0) {
			//Do % expansion
			getData(item, pctPos, pctBuff);
			int x=0;
			while (pctBuff[x]!=0) {
				dst[j]=pctBuff[x];
				j++; x++;
			}
			pctPos++;
		} else {
			dst[j]=c;
			j++;
		}
		i++;
	}
	//Zero-terminate
	dst[j]=0;
	return dst;
}

static void menuDraw(PGM_P menuString, void (getData)(int menuItem, int no, char* buff)) {
	char buff[80];
	int i;
	char *itemTxt;
	//ToDo: Make prettier with ansi-chars etc
	printf_P(PSTR("\033[2J +++ %s +++\n"),getSubStr(menuString, 0, buff, getData));
	
	i=1;
	do {
		itemTxt=getSubStr(menuString, i, buff, getData);
		if (itemTxt!=NULL) printf_P(PSTR("%i. %s\n"), i, itemTxt);
		i++;
		if (i==20) return;
	} while (itemTxt!=NULL);
	printf_P(PSTR("0. Back\n"));
}

int menuShow(PGM_P menuString, void (getData)(int menuItem, int no, char* buff)) {
	menuDraw(menuString, getData);
	char c=0;
	do {
		c=getchar();
	} while ( c<'1' && c>'9');
	return c-'1'+1;
}



